<template>
  <div>
    <div
      ref="chart"
      style="width: 100%; height: 300px;"
    />
  </div>
</template>

<script>
export default {
  props: {
    dec: {
      type: Number,
      default: 0,
    },
    ra: {
      type: Number,
      default: 0,
    },
  },

  data() {
    return {
      chart: null,
    };
  },

  watch: {
    dec() {
      this.gotoRaDec(this.ra, this.dec);
    },
    ra() {
      this.gotoRaDec(this.ra, this.dec);
    },
  },

  mounted() {
    this.load();
  },

  methods: {
    async load() {
      await this.loadScriptIntoDOM('//code.jquery.com/jquery-1.12.1.min.js');
      await this.loadScriptIntoDOM('//aladin.u-strasbg.fr/AladinLite/api/v2/beta/aladin.min.js');
      this.aladinStatus = 'ready';
      /* eslint-disable-next-line no-undef */
      this.chart = A.aladin(this.$refs.chart, {
        survey: 'P/PanSTARRS/DR1/color/z/zg/g',
        fov: 0.02,
      });
      this.gotoRaDec(this.ra, this.dec);
    },

    async loadScriptIntoDOM(url) {
      const scriptElement = document.createElement('script');
      scriptElement.setAttribute('src', url);
      scriptElement.async = false;
      const promise = new Promise((resolve, reject) => {
        scriptElement.onload = () => resolve();
        scriptElement.onerror = () => reject();
      });
      this.$el.appendChild(scriptElement);
      return promise;
    },

    gotoRaDec(ra, dec) {
      if (this.chart) {
        this.chart.gotoRaDec(ra, dec);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
@import 'aladin.min.css';
</style>
